/*
 * This code is based on the Foedus IMAP server, originally written by David Weitzman.  
 * http://sourceforge.net/projects/foedus
 */
package rice.email.proxy.pop3.commands;

import rice.email.proxy.mailbox.*;
import rice.email.proxy.pop3.*;
import rice.email.proxy.user.*;

public class UserCommand extends Pop3Command {
  
  public boolean isValidForState(Pop3State state) {
    return !state.isAuthenticated();
  }
  
  public void execute(Pop3Connection conn, Pop3State state, String cmd) {
    try {
      String[] args = cmd.split(" ");
      if (args.length < 2) {
        conn.println("-ERR Required syntax: USER <username>");
        
        return;
      }
      
      String username = args[1];
      state.setUser(state.getUser(username));
      conn.println("+OK");
    } catch (MailboxException me) {
      conn.println("-ERR " + me);
    }
    catch (UserException nsue) {
      conn.println("-ERR " + nsue);
    }
  }
}